(* $Id: sexec.ml 858 2008-02-10 22:21:11Z isr $ *)
open Big_int
open Utils
open Ttype
open Vars
open Stype
open Slib

let rec evaluateSExpArgs vmng (el: scm_exp list) : varValue list =
  match el with
    [] -> []
  | e::el' -> begin
      let v = match e.seType with
        SCM_EXP -> evaluateSExp vmng e
      | SCM_SYMBOL -> (findVarDef vmng (seGetLabel e)).vdValue
      | _ -> evaluateSExp vmng e
      in
      v::evaluateSExpArgs vmng el'
  end

and evaluateSExp vmng (e: scm_exp) : varValue =
  match e.seType with
    SCM_SYMBOL -> VStr (seGetLabel e) (* TODO *)
  | SCM_FLOAT -> VFloat (float_of_string (seGetLabel e))
  | SCM_INT -> VInt (big_int_of_string (seGetLabel e))
  | SCM_STRING -> VStr (seGetLabel e)
  | SCM_EXP ->
      match e.seExp with
        [] -> vzero (* TODO *)
      | ee::eel -> begin
        let name = seGetLabel ee in
        (* TODO: Be elegant. *)
        try
          let f = (Hashtbl.find scm_lib_side_effect_func_table name) in
          let vname = seGetLabel (List.hd eel) in
          f vmng vname (evaluateSExpArgs vmng (List.tl eel))
        with Not_found ->
          let vargs = evaluateSExpArgs vmng eel in
          try 
            (Hashtbl.find scm_lib_func_table name) vargs
          with Not_found ->
            Texec.callFunc ((Vars.findVarDef vmng name).vdValue) vargs
      end

let scmexec (e: scm_exp) (vmng: varManager) : unit = 
  ignore(evaluateSExp vmng e)
