(* $Id: slib.ml 871 2008-02-12 04:16:53Z isr $ *)
open Ttype
open Tlib
open Stype

(* TODO: Because of eazy implementation, wrong behavior maybe. *)
let rec scm_define vmng name (vs: varValue list) : varValue =
  Vars.asgnVarDef vmng (initVarDefWithName name (List.hd vs));
  (List.hd vs)


let rec scm_add' sum (vs: varValue list) : varValue =
  match vs with
    [] -> sum
  | v::vs' -> scm_add' (Texec.vvAdd sum v) vs'
let scm_add (vs: varValue list) : varValue =
  scm_add' vzero vs


let rec scm_minus' sum (vs: varValue list) : varValue =
  match vs with
    [] -> sum
  | v::vs' -> scm_minus' (Texec.vvMinus sum v) vs'
let scm_minus (vs: varValue list) : varValue =
  match List.length vs with
    0 -> assert false
  | 1 -> Texec.vvUminus (List.hd vs)
  | _ -> scm_minus' (List.hd vs) (List.tl vs)


let rec scm_multi' sum (vs: varValue list) : varValue =
  match vs with
    [] -> sum
  | v::vs' -> scm_multi' (Texec.vvTimes sum v) vs'
let scm_multi (vs: varValue list) : varValue =
  scm_multi' vunit vs


let rec scm_div' sum (vs: varValue list) : varValue =
  match vs with
    [] -> sum
  | v::vs' -> scm_div' (Texec.vvDiv sum v) vs'
let scm_div (vs: varValue list) : varValue =
  match List.length vs with
    0 -> assert false
  | 1 -> Texec.vvDiv vunit (List.hd vs)
  | _ -> scm_div' (List.hd vs) (List.tl vs)


let scm_display (vs: varValue list) : varValue =
  print_endline (showVal (List.hd vs));
  vzero


let scm_lib_side_effect_func_table =
  Utils.create_hashtable 32 [
    ("define",    scm_define);
  ]

let scm_lib_func_table =
  Utils.create_hashtable 32 [
    ("+",         scm_add);
    ("-",         scm_minus);
    ("*",         scm_multi);
    ("/",         scm_div);
    ("display",   scm_display);
  ]
