%{
(* $Id: sparser.mly 858 2008-02-10 22:21:11Z isr $ *)
  open Big_int
  open Stype
%}

%token <bool>  BOOL
%token <char>  CHAR
%token <float> FLOAT
%token <Big_int.big_int> INT
%token <string> STRING SYMBOL

%token SPAREN
%token LPAREN
%token RPAREN
%token QUOTE
%token QUASIQUOTE
%token UNQUOTE
%token UNQUOTESPLICE
%token PERIOD

%start input
%type <Stype.scm_exp> input

%%
input:
  exp { $1 }

exp:
    BOOL   { (* TODO *)
      if $1 then initSExp SCM_INT (Some (string_of_big_int unit_big_int)) []
      else initSExp SCM_INT (Some (string_of_big_int zero_big_int)) []
  }
  | INT    { initSExp SCM_INT    (Some (string_of_big_int $1)) [] }
  | FLOAT  { initSExp SCM_FLOAT  (Some (string_of_float $1)) [] }
  | STRING { initSExp SCM_STRING (Some $1) [] }
  | SYMBOL { initSExp SCM_SYMBOL (Some $1) [] }
  | LPAREN exp_list RPAREN { initSExp SCM_EXP None $2 }

exp_list :
    {[]}
  | exp exp_list { $1::$2 }

%%

