(* $Id: utils.ml 835 2008-02-08 10:04:02Z isr $ *)

let (@@) f x = f x

let fromJust x = match x with
    (Some x) -> x
  | _ -> assert false

let create_hashtable size init =
  let tbl = Hashtbl.create size in
  List.iter (fun (key, data) -> Hashtbl.add tbl key data) init;
  tbl

(*
 * DEBUG print. (by easy implementation)
 *)
let dput s =
    ()  (* or print_endline s *)
    (* print_endline s or () *)


(* Return the n-th element of the given list. *)
let nthList (i: int) (lst: 'a list) : 'a = List.nth lst i

let cutHeadNEle (n: int) (ar: 'a array) : 'a array =
  Array.sub ar n (Array.length ar -n)
let cutHeadEle ar = cutHeadNEle 1 ar

let rec cutHeadNEleL (n: int) (l: 'a list) : 'a list =
  if n = 1 then List.tl l
  else cutHeadNEleL (n-1) (List.tl l)
let cutHeadEleL l = cutHeadNEleL 1 l

let cutHeadNChar (n: int) (s: string) : string =
  String.sub s n (String.length s - n)
let cutHeadChar s = cutHeadNChar 1 s

